VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "C64 Ram!"
   ClientHeight    =   2760
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   9615
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2760
   ScaleWidth      =   9615
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame3 
      Caption         =   "C64 Serial Controls"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2535
      Left            =   3720
      TabIndex        =   12
      Top             =   120
      Width           =   2175
      Begin VB.CommandButton cmdOpenClosePort 
         Caption         =   "OPEN"
         Height          =   495
         Left            =   360
         TabIndex        =   15
         Top             =   1560
         Width           =   1335
      End
      Begin VB.ComboBox cboPort 
         Height          =   315
         Left            =   360
         TabIndex        =   14
         Top             =   720
         Width           =   1215
      End
      Begin VB.Label Label4 
         Caption         =   "COMM PORT"
         Height          =   255
         Left            =   240
         TabIndex        =   13
         Top             =   360
         Width           =   1095
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "C64 RAM Controls"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2535
      Left            =   6000
      TabIndex        =   1
      Top             =   120
      Width           =   3495
      Begin VB.CommandButton cmdSaveRAM 
         Caption         =   "Save RAM"
         Height          =   375
         Left            =   1800
         TabIndex        =   11
         Top             =   1080
         Width           =   1335
      End
      Begin VB.CommandButton cmdLoadRAM 
         Caption         =   "Load RAM"
         Height          =   375
         Left            =   240
         TabIndex        =   10
         Top             =   1080
         Width           =   1335
      End
      Begin VB.CommandButton cmdExit 
         Caption         =   "Exit"
         Height          =   375
         Left            =   1080
         TabIndex        =   9
         Top             =   1800
         Width           =   1335
      End
      Begin VB.CommandButton cmdFormatRAM 
         Caption         =   "Format RAM"
         Height          =   375
         Left            =   1080
         TabIndex        =   8
         Top             =   480
         Width           =   1335
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "C64 RAM Status!"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2535
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3495
      Begin MSCommLib.MSComm MSComm1 
         Left            =   1440
         Top             =   1920
         _ExtentX        =   1005
         _ExtentY        =   1005
         _Version        =   393216
         DTREnable       =   0   'False
         InputMode       =   1
      End
      Begin VB.TextBox txtHighestAddr 
         Height          =   285
         Left            =   1680
         Locked          =   -1  'True
         TabIndex        =   7
         Text            =   "NA"
         Top             =   1320
         Width           =   1335
      End
      Begin VB.TextBox txtCurrentData 
         Height          =   285
         Left            =   1680
         Locked          =   -1  'True
         TabIndex        =   5
         Text            =   "NA"
         Top             =   840
         Width           =   1335
      End
      Begin VB.TextBox txtCurrentAddr 
         Height          =   285
         Left            =   1680
         Locked          =   -1  'True
         TabIndex        =   4
         Text            =   "NA"
         Top             =   480
         Width           =   1335
      End
      Begin VB.Label Label3 
         Caption         =   "Highest Addr:"
         Height          =   255
         Left            =   240
         TabIndex        =   6
         Top             =   1320
         Width           =   975
      End
      Begin VB.Label Label2 
         Caption         =   "Current Data:"
         Height          =   255
         Left            =   240
         TabIndex        =   3
         Top             =   840
         Width           =   1095
      End
      Begin VB.Label Label1 
         Caption         =   "Current Address:"
         Height          =   255
         Left            =   240
         TabIndex        =   2
         Top             =   480
         Width           =   1335
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const ForReading = 1, ForWriting = 2, ForAppending = 3
Const gsProgramName = "C64RAM"
Const RAM_GETADDRESS = 1
Const RAM_WRITE = 2

Dim mbOpenClosedPort As Boolean

Dim mlLargestAddress As Long
Dim mlCurrentAddress As Long
Dim miRecieve_mode As Integer
Dim mlNewValue As Long

Dim mvC64RAMobject(128000) As Long

Private Sub Add2Ports(rsCommPort As String, riCommItemData As Integer)
    cboPort.AddItem rsCommPort
    cboPort.ItemData(cboPort.NewIndex) = riCommItemData
End Sub

Private Sub cmdExit_Click()
    If MsgBox("Are you sure?", vbCritical + vbYesNo + vbDefaultButton2, gsProgramName) = vbYes Then
        End
    End If
End Sub

Private Sub cmdFormatRAM_Click()
    If MsgBox("Are you sure?", vbCritical + vbYesNo + vbDefaultButton2, gsProgramName) = vbYes Then
        Call FormatRAM
        mlLargestAddress = 0
        txtCurrentData.Text = ""
        txtCurrentAddr.Text = ""
        txtHighestAddr.Text = ""
    End If
End Sub

Private Sub cmdLoadRAM_Click()
    If MsgBox("This will overwrite current RAM.  Are you sure?", vbCritical + vbYesNo + vbDefaultButton2, gsProgramName) = vbYes Then
        Call LoadDataArray
    End If
End Sub

Private Sub cmdOpenClosePort_Click()
    On Error GoTo cmdOpenClosePort_error
    
    If MSComm1.PortOpen = True Then
        MSComm1.PortOpen = False
        cmdOpenClosePort.Caption = "Port is CLOSED"
    Else
        Debug.Print "setting port to " & cboPort.ItemData(cboPort.ListIndex)
        MSComm1.CommPort = cboPort.ItemData(cboPort.ListIndex)
        Call SaveSetting(gsProgramName, "comm", "commport", cboPort.ListIndex)
        MSComm1.PortOpen = True
        cmdOpenClosePort.Caption = "Port is OPEN"
    End If
Exit Sub

cmdOpenClosePort_error:
    MsgBox "ERROR: " & Err.Number & " - " & Err.Description
    Err.Clear
    cmdOpenClosePort.Caption = "Port is CLOSED"
End Sub

Private Sub cmdSaveRAM_Click()
    If MsgBox("Are you sure?", vbCritical + vbYesNo + vbDefaultButton2, gsProgramName) = vbYes Then
        Call SaveDataArray
    End If
End Sub

Private Sub Form_Load()
    On Error GoTo form_port_open
    
    mlLargestAddress = 0
    mlCurrentAddress = 0
    mlLargestAddress = 0
    
    ' format ram
    FormatRAM
    
    Debug.Print mvC64RAMobject(200)
    
    ' load the ports
    cboPort.Clear
    Add2Ports "COM1", 1
    Add2Ports "COM2", 2
    Add2Ports "COM3", 3
    Add2Ports "COM4", 4
    Add2Ports "COM5", 5
    Add2Ports "COM6", 6
    Add2Ports "COM7", 7
    Add2Ports "COM8", 8
    Add2Ports "COM9", 9
    Add2Ports "COM10", 10
    
    ' default
    cboPort.ListIndex = GetSetting(gsProgramName, "comm", "commPort", 1)
    
    ' init the MSCOMM1
    ' set defaults
    With MSComm1
        .CommPort = 7
        .RThreshold = 1
        .Settings = "115200,n,8,1"
        .SThreshold = 1
        .InputMode = comInputModeText
        .PortOpen = False
    End With
Exit Sub

form_port_open:
    cmdOpenClosePort.Caption = "Port is CLOSED!"
End Sub

Private Sub LoadDataArray()
    Dim ml As Long, data1 As Long
    Dim fs, InputFile
    Dim msLine As String
       
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set InputFile = fs.OpenTextFile("c:\ramSave.txt", ForReading)
    
    Call FormatRAM
    
    While InputFile.atendofstream = False
        msLine = InputFile.readline
        
        ' get from file
        ml = Int(Mid(msLine, 1, InStr(msLine, ",")))
        data1 = Int(Mid(msLine, InStr(msLine, ",") + 1))
        
        'set it
        mvC64RAMobject(ml) = data1
        
    Wend
    InputFile.Close
        
End Sub

Private Sub SaveDataArray()
    Dim ml As Long
    Dim fs, OutputFile
    
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set OutputFile = fs.OpenTextFile("c:\ramSave.txt", ForWriting, True)
    
    For ml = 0 To UBound(mvC64RAMobject) Step 1
        If mvC64RAMobject(ml) <> 0 Then
            OutputFile.writeline ml & "," & mvC64RAMobject(ml)
        End If
    Next
    OutputFile.Close
End Sub

Private Sub FormatRAM()
    Dim mi As Long
    
    For mi = 0 To UBound(mvC64RAMobject)
        mvC64RAMobject(mi) = 0
    Next
End Sub

Private Sub MSComm1_OnComm()
    Dim msInBuffer As String

    Select Case MSComm1.CommEvent
        ' Errors
        Case comEventBreak   ' A Break was received.
        Case comEventCDTO    ' CD (RLSD) Timeout.
        Case comEventCTSTO   ' CTS Timeout.
        Case comEventDSRTO   ' DSR Timeout.
        Case comEventFrame   ' Framing Error.
        Case comEventOverrun ' Data Lost.
        Case comEventRxOver  ' Receive buffer overflow.
        Case comEventRxParity ' Parity Error.
        Case comEventTxFull  ' Transmit buffer full.
        Case comEventDCB     ' Unexpected error retrieving DCB]

         ' Events
        Case comEvCD        ' Change in the CD line.
        Case comEvCTS       ' Change in the CTS line.
        Case comEvDSR       ' Change in the DSR line.
        Case comEvRing      ' Change in the Ring Indicator.
        Case comEvReceive   ' Received RThreshold # of chars.
            msInBuffer = MSComm1.Input
            Call ProcessCOMMData(msInBuffer)
              
        Case comEvSend ' There are SThreshold number of
                       ' characters in the transmit buffer.
        Case comEvEOF  ' An EOF character was found in the
                       ' input stream.
    End Select
End Sub

Private Sub ProcessCOMMData(rsInput As String)
    Dim mi As Integer
    Dim miS As Integer
    Dim miX As Integer
    Dim msTmpString As String
    
    'Debug.Print "got " & Len(rsInput) & " - " & rsInput

    For mi = 1 To Len(rsInput)
    
        ' input char
        miS = Asc(Mid(rsInput, mi, 1))
     
        ' if get marker
        If miS = 169 Then
            ' get marker
            mlCurrentAddress = 0
            mlNewValue = 0
            miRecieve_mode = RAM_GETADDRESS
            'Debug.Print "get address"
                                
        ElseIf miS = 170 Then ' READ
        
            ' check for highest
            If mlCurrentAddress > mlLargestAddress Then
                mlLargestAddress = mlCurrentAddress
                txtHighestAddr.Text = mlLargestAddress
            End If
        
            ' debug
            Debug.Print "returning address " & mlCurrentAddress & " which is " & mvC64RAMobject(mlCurrentAddress)
            ' update screen
            txtCurrentAddr.Text = mlCurrentAddress
            If mlCurrentAddress < UBound(mvC64RAMobject) Then
                txtCurrentData.Text = mvC64RAMobject(mlCurrentAddress)
                ' return to Propeller (C64)
                'Debug.Print "current data is : " & mvC64RAMobject(mlCurrentAddress)
                msTmpString = CStr(mvC64RAMobject(mlCurrentAddress))
                            
                For miX = 1 To Len(msTmpString)
                    MSComm1.Output = Chr(Mid(msTmpString, miX, 1) + 48)
                    'Debug.Print Mid(msTmpString, miX, 1)
                Next
                ' end marker
                MSComm1.Output = Chr(173)
            Else
                'Debug.Print "invalid " & mlCurrentAddress
                MSComm1.Output = 0
            End If
            
        ElseIf miS = 171 Then ' WRITE
            ' check for highest
            If mlCurrentAddress > mlLargestAddress Then
                mlLargestAddress = mlCurrentAddress
                txtHighestAddr.Text = mlLargestAddress
            End If
            
            ' debug
            Debug.Print "Writing to " & mlCurrentAddress
            miRecieve_mode = RAM_WRITE
            
        ElseIf miS = 172 Then ' commit write
            'Debug.Print "writeing value " & mlNewValue
            mvC64RAMobject(mlCurrentAddress) = mlNewValue
                       
        ElseIf miS >= 48 And miS <= 57 Then
            ' get address -
            Select Case miRecieve_mode
                Case RAM_GETADDRESS
                    ' get address
                    'Debug.Print "gotA " & miS
                    mlCurrentAddress = mlCurrentAddress * 10
                    mlCurrentAddress = mlCurrentAddress + (miS - 48)
                Case RAM_WRITE
                    ' get data to write
                    'Debug.Print "gotW " & miS
                    mlNewValue = mlNewValue * 10
                    mlNewValue = mlNewValue + (miS - 48)
                    
            End Select
        End If
   Next
End Sub
